﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function NGRJANUSDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "NGRJANUSDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "NGRJANUSDataLoader_F(",CC_Replacement,")"
			NGRJANUSDataLoader_F( CC_Replacement )
	End
	
	Function NGRJANUSDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			String SiteNum, Hole
			WAVE/T H, TW
			WAVE Leg,Site,Cor,Sc,Top_cm_,Depth__mbsf_,Corr__Counts,Total_Counts
			If( !WaveExists( Corr__Counts ) )
				Print "I can't find the datawave \"Corr__Counts\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are NGR data from JANUS?"
				ABORT "I can't find the datawave \"Corr__Counts\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are NGR data from JANUS?"
			EndIf
			If( NumType( Cor[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1,   H,TW,Leg,Site,Cor,Sc,Top_cm_,Depth__mbsf_,Corr__Counts,Total_Counts
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "Corr__Counts", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Hole = "U" + Num2Str( Site[ 0 ] ) + H[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_NGR"
			Replace_NaNswithNumber_F( "Sc", CC_Replacement )
			Duplicate/O H, $":" + SiteNum + "_NGR:" + Hole + "_NGR_Hole"; 
			Duplicate/O Cor, $":" + SiteNum + "_NGR:" + Hole + "_NGR_Core"; 
			Duplicate/O TW, $":" + SiteNum + "_NGR:" + Hole + "_NGR_Type"; 
			Duplicate/O Sc, $":" + SiteNum + "_NGR:" + Hole + "_NGR_Section"; 
			Duplicate/O Top_cm_, $":" + SiteNum + "_NGR:" + Hole + "_NGR_Interval"; 
			Duplicate/O Depth__mbsf_, $":" + SiteNum + "_NGR:" + Hole + "_NGR_mbsf"; 
			Duplicate/O Corr__Counts, $":" + SiteNum + "_NGR:" + Hole + "_NGR_NGR"
			Duplicate/O Total_Counts, $":" + SiteNum + "_NGR:" + Hole + "_NGR_TotalCnts"
			Duplicate/O H, $":" + SiteNum + "_NGR:" + Hole + "_NGR_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_NGR:" + Hole + "_NGR_Site"
			SiteWv = SiteNum
			EmptyJANUSDataTable( )
			Killwaves H, TW
			KillWaves Leg,Site,Cor,Sc,Top_cm_,Depth__mbsf_,Corr__Counts,Total_Counts
	End