﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


// This function creates a movie by advancing a selected axis of the top graph by a user-selected increment per frame	
	
//	Function MakeDepthScanMovie()
		SetDataFolder root:
			Variable/G G_InitialDepth, G_FinalDepth, G_DepthRange, G_FrameRate, G_DepthIncrement
			Variable InitialDepth = G_InitialDepth, FinalDepth = G_FinalDepth, DepthRange = G_DepthRange, i
			Variable FrameRate = G_FrameRate, DepthIncrement = G_DepthIncrement
			String/G G_Axis, G_ScrollDirection
			String Axis = G_Axis, ScrollDirection = G_ScrollDirection
			Prompt Axis, "Select Axis to Increment:", popup, AxisList( "" )
			Prompt InitialDepth, "Initial Depth/Age:"
			Prompt FinalDepth, "Final Depth/Age:"
			Prompt DepthIncrement, "Depth/Age Increment per Frame:"
			Prompt DepthRange, "Range of Depth/Age for a single frame ( e.g. 25 m ):"
			Prompt ScrollDirection, "Scroll Direction:", popup, "Left;Right;Up;Down"
			Prompt FrameRate, "Movie frame rate ( /sec ):"
			DoPrompt "MakeDepthScanMovie", Axis, InitialDepth, FinalDepth, DepthRange, DepthIncrement, ScrollDirection, FrameRate
			G_InitialDepth = InitialDepth; G_FinalDepth = FinalDepth; G_DepthRange = DepthRange; G_ScrollDirection = ScrollDirection
			G_FrameRate = FrameRate; G_DepthIncrement = DepthIncrement; G_Axis = Axis; AbortOnValue V_Flag, 0
			If( FinalDepth < InitialDepth && DepthIncrement > 0 ) // Check to see which way to scroll the data - high to low or the reverse.
				DepthIncrement *= -1 // Use a negative increment if scrolling from high to low. User may enter a negative value or the function changes the sign of a positive value
			Endif
			If( FinalDepth > InitialDepth && DepthIncrement < 0 )
				DepthIncrement *= -1 // Use a negative increment if scrolling from high to low. User may enter a negative value or the function changes the sign of a positive value
			Endif
			CloseMovie/Z // In case a movie is already open from a previous runtime error
			NewMovie/O/CF = 100/F = ( FrameRate ) // These Flags may need to be modified when running on a Windows machine
													  // A dialog opens for naming the movie and choosing where to put it on your drive													  
			Variable LeftVal, RightVal			
			If( ( StringMatch( ScrollDirection, "Left" ) || StringMatch( ScrollDirection, "Down" ) )  && DepthIncrement > 0 ) // Increasing values
				LeftVal = InitialDepth								// First set the limits of the axis for the first frame of the movie
				RightVal = InitialDepth + DepthRange				
				SetAxis $Axis LeftVal, RightVal				// Set the axis
				DoUpdate;														// Update the graph for the next movie frame
				AddMovieFrame 												// Captures the graph in a movie frame
				For( i = 0; RightVal < FinalDepth; i += 1 ) // Now use this loop to scan through the data
					LeftVal += DepthIncrement 							// Increment limits of the axis
					RightVal += DepthIncrement
					SetAxis $Axis LeftVal, RightVal				// Set the axis
					DoUpdate;														// Update the graph for the next movie frame
					AddMovieFrame 												// Captures the graph in a movie frame
				EndFor
			EndIf
			If( ( StringMatch( ScrollDirection, "Right" ) || StringMatch( ScrollDirection, "Up" ) )  && DepthIncrement > 0 ) // Increasing values
				LeftVal = InitialDepth + DepthRange		
				RightVal = InitialDepth			
				SetAxis $Axis LeftVal, RightVal
				DoUpdate;	
				AddMovieFrame // Captures the graph in a movie frame
				For( i = 0; LeftVal < FinalDepth; i += 1 )
					LeftVal += DepthIncrement
					RightVal += DepthIncrement
					SetAxis $Axis LeftVal, RightVal
					DoUpdate;
					AddMovieFrame // Captures the graph in a movie frame
				EndFor
			EndIf
			If( ( StringMatch( ScrollDirection, "Right" ) || StringMatch( ScrollDirection, "Up" ) )  && DepthIncrement < 0 ) // Decreasing values
				LeftVal = InitialDepth	
				RightVal = InitialDepth	- DepthRange		
				SetAxis $Axis LeftVal, RightVal
				DoUpdate;
				AddMovieFrame // Captures the graph in a movie frame
				For( i = 0; RightVal > FinalDepth; i += 1 )
					LeftVal += DepthIncrement
					RightVal += DepthIncrement
					SetAxis $Axis LeftVal, RightVal
					DoUpdate;
					AddMovieFrame // Captures the graph in a movie frame
				EndFor
			EndIf
			If( ( StringMatch( ScrollDirection, "Left" ) || StringMatch( ScrollDirection, "Down" ) )  && DepthIncrement < 0 ) // Decreasing values
				LeftVal = InitialDepth	
				RightVal = InitialDepth - DepthRange				
				SetAxis $Axis LeftVal, RightVal
				DoUpdate;
				AddMovieFrame // Captures the graph in a movie frame
				For( i = 0; RightVal > FinalDepth; i += 1 )
					RightVal += DepthIncrement
					LeftVal += DepthIncrement
					SetAxis $Axis LeftVal, RightVal
					DoUpdate;
					AddMovieFrame // Captures the graph in a movie frame
				EndFor
			EndIf
			CloseMovie // Closes the movie
	End	

---------------------------------------------------------------------------------------------------------------
	
// This function creates a movie by advancing the depth scale of the top graph by 1 m per frame	
	
//	Function MakeDepthScanMovie() // Old simple version  
		SetDataFolder root:
			Variable/G G_InitialDepth, G_FinalDepth, G_DepthRange
			Variable InitialDepth = G_InitialDepth, FinalDepth = G_FinalDepth, DepthRange = G_DepthRange, i
			Prompt InitialDepth, "Top Depth:"
			Prompt FinalDepth, "Bottom Depth:"
			Prompt DepthRange, "Range of Depth for a single frame ( e.g. 25 m ):"
			DoPrompt "MakeDepthScanMovie", InitialDepth, FinalDepth, DepthRange
			G_InitialDepth = InitialDepth; G_FinalDepth = FinalDepth; G_DepthRange = DepthRange
			AbortOnValue V_Flag, 0
			NewMovie/O/CF = 100/F = 5 // These Flags may need to be modified when running on a Windows machine
													  // A dialog opens for naming the movie and choosing where to put it on your drive
			For( i = InitialDepth; i + DepthRange <= FinalDepth; i += 1 ) // This loop increments depths by 1 m and then captures a movie frame
				SetAxis Age i, i + DepthRange // Changes the range of the Botttom ( depth ) axis
				DoUpDate // This line makes sure that the graph is changed every time through the loop
				AddMovieFrame // Captures the graph in a movie frame
			EndFor	 
			CloseMovie // Closes the movie
	End	
	
	Function MakeDepthScanMovie() // Version to use with Igor 7 
		SetDataFolder root:
			Variable/G G_InitialDepth, G_FinalDepth, G_DepthRange
			Variable InitialDepth = G_InitialDepth, FinalDepth = G_FinalDepth, DepthRange = G_DepthRange, i
			Prompt InitialDepth, "Top Depth:"
			Prompt FinalDepth, "Bottom Depth:"
			Prompt DepthRange, "Range of Depth for a single frame ( e.g. 25 m ):"
			DoPrompt "MakeDepthScanMovie", InitialDepth, FinalDepth, DepthRange
			G_InitialDepth = InitialDepth; G_FinalDepth = FinalDepth; G_DepthRange = DepthRange
			AbortOnValue V_Flag, 0
			NewMovie/O/F = 5/CTYP = "jpeg" // These Flags may need to be modified when running on a Windows machine
																// A dialog opens for naming the movie and choosing where to put it on your drive
			For( i = InitialDepth; i + DepthRange <= FinalDepth; i += 1 ) // This loop increments depths by 1 m and then captures a movie frame
				SetAxis Bottom i, i + DepthRange
				DoUpDate // This line makes sure that the graph is changed every time through the loop
				AddMovieFrame // Captures the graph in a movie frame
			EndFor	 
			CloseMovie // Closes the movie
	End