﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function GRANGDCDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "GRANGDCDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "GRANGDCDataLoader_F(",CC_Replacement,")"
			GRANGDCDataLoader_F( CC_Replacement )
	End
	
	Function GRANGDCDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			Variable i, j
			Variable/G G_HoleVorS
			String WvList = WaveList( "Wave*", ";", "" )
			If( ItemsInList( WvList ) < 15 )
				ABORT "There are only " + Num2Str( ItemsInList( WvList ) ) + " waves in the NGDCDataTable.\r\rThere should be around 160 for a full section.\r\rDid you forget and copy the header row along with the data?"
			EndIf
			EXECUTE "G_HoleVorS = WaveType( Wave2 )" // This necessary for DSDP data as the first Hole was "blank" and the second Hole is "A".
			If( G_HoleVorS == 2 || G_HoleVorS == 4 )									// The Hole wave is read as a numerical wave and must be replaced with a text wave with value "X"
				DoWindow/F NGDCDataTable
				EXECUTE "RemoveFromTable Wave2"
				EXECUTE "KillWaves Wave2 "
				EXECUTE "Make/T/N = ( NumPnts( Wave1 ) ) Wave2"
				EXECUTE "Wave2 = \"X\""
				EXECUTE "AppendToTable Wave2"
			Endif
			WAVE Wave1, Wave3, Wave4
			WAVE/T Wave2
			String SiteNum = "U" + Num2Str( Wave1[0] ), H = "U" + Num2Str( Wave1[ 0 ] ) + Wave2[ 0 ]
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "NGDCDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:NGDCDataTable" ), "wave0", 0 ) < 0 ) // Checks that the data are in the designated Table named "NGDCDataTable"
				Print "The data are not in a table named \"NGDCDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyNGDCDataTable()\r\t\tfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"NGDCDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyNGDCDataTable\"\r\rfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Variable MeasPnts = ItemsInList( WvList ) - 12
			Variable NumSections = NumPnts( Wave1 )
			Make/O/N = ( MeasPnts, NumSections ) $H + "_GRA_GRA" // GRA data wave is intially a matrix - each section is a column in the matrix
			WAVE GRAData = $H + "_GRA_GRA"
			GRAData = NaN
			For( j = 0; j < NumSections; j += 1 ) // Fills in the matrix of GRA data
				For( i = 0; i < MeasPnts; i += 1 )
					WAVE Wv = $StringFromList( i + 12, WvList )
					GRAData[i][j] = Wv[j]	
				EndFor
			EndFor
			ReDimension/N = ( DimSize( GRAData, 0 ) * DimSize( GRAData, 1 ) ) GRAData	// Matrix filled, it is transformed into one long column of GRA measurements
			Make/O/N = ( NumPnts( GRAData ) ) $H + "_GRA_Core", $H + "_GRA_Section", $H + "_GRA_Interval", $H + "_GRA_mbsf"
			Make/T/O/N = ( NumPnts( GRAData ) ) $H + "_GRA_Site", $H + "_GRA_Hole"
			WAVE Core = $H + "_GRA_Core", Section = $H + "_GRA_Section", Interval = $H + "_GRA_Interval", MBSF = $H + "_GRA_mbsf"	
			WAVE/T Site = $H + "_GRA_Site", Hole = $H + "_GRA_Hole"
			MBSF = NaN; Core = NaN; Section = NaN; Interval = NaN; Hole = ""
			Site = "U" + Num2Str( Wave1[0] ); Hole = Wave2[0]			
			For( i = 0; i < NumSections; i += 1 ) // Fills in the Core and Section values
				If( i == 0 )
					Core[ i, (MeasPnts-1) ] = Wave3[ i ]
					Section[ i, (MeasPnts-1) ] = Wave4[ i ]
				Else
					Core[ i * MeasPnts , ((i+1) * MeasPnts) -1 ] = Wave3[ i ]					
					Section[ i * MeasPnts , ((i+1) * MeasPnts) -1 ] = Wave4[ i ]					
				EndIf
			EndFor	
			For( i = 0; i < NumPnts( Site ); i += 1 ) // This loop gets rid of 0 values before and after measurements - before calculating Interval
				If( GRAData[i] == 0 )
					DeletePoints i,1, GRAData, Site, Hole, Core, Section, Interval, MBSF
					i -= 1
				EndIf
			EndFor	
			WAVE Wave6, Wave7	// Wave6 holds the top depths to each section used below to form a temporary coring matrix
			Variable MeasIncr = Wave7[0]	// The measurement increment for the GRA values
			Duplicate/O Section Temp // Temp is used to find changes in Section and restart Increment calculation at 1 * MeasIncr
			InsertPoints 0,1, Temp
			For( i = 0; i < NumPnts( Site ); i += 1 ) // This loop calculates the Increment
				If( Section[i] != Temp[i] )
					j = 1
				EndIf
				Interval[i] = j * MeasIncr
				j += 1                                                                                                                                                                                                                                                                                    
			EndFor	
			Make/O/N = ( WaveMax( Wave3 ) + 1, 10 ) CMatrix // CMatrix is a temporary coring matrix derived from the dataset
			CMatrix = NaN																// It is used below to calculate mbsf, then killed
			For( i = 0; i < NumPnts( Wave1 ); i += 1 )
				CMatrix[ Wave3[i] ][ Wave4[i] ] = Wave6[i]
			EndFor
			CMatrix -= .01
			MBSF = CMatrix[ Core ][ Section ][ 0 ] + Interval/100
			NewDataFolder/O $"U" + Num2Str( Wave1[0] ) + "_GRA"
			Replace_NaNswithNumber_F( H + "_GRA_Section", CC_Replacement )
			EmptyNGDCDataTable( )
			String KillList = WaveList( H + "_GRA_*", ";", "" )
			For( i = 0; i < ItemsInList( KillList ); i += 1 )
				Duplicate/O $StringFromList( i, KillList ), $":U" + Num2Str( Wave1[0] ) + "_GRA:" + StringFromList( i, KillList )
				KillWaves $StringFromList( i, KillList )//, ":U" + Num2Str( Wave1[0] ) + "_GRA:" + StringFromList( i, KillList )
			EndFor			
			KillList = WaveList( "Wave*", ";", "" )
			For( i = 0; i < ItemsInList( KillList ); i += 1 ) // Work-around because the wave list is too long for a single KillWaves command
				EXECUTE "KillWaves " + StringFromList( i, KillList )
			EndFor			
			KillWaves Temp, CMatrix
	End		
