﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// This function checks to see if a number > 9 is used for core catchers in a coring matrix
// If so, it asks whether to continue. If Continue is chosen a flag is set so that the question will not be repeated until the flag is reset

	Function CheckMatrix4CCNumber( Hole )
		String Hole
		Variable/G V_Flag_CCNumber		
		Variable CCNumber, NumRows, i
		Wave Matrix = $Hole + "_Coring_Matrix"
		WaveStats/Q Matrix
		NumRows = V_MaxRowLoc
		For( i = 0; i <= NumRows; i += 1 )
			Duplicate/O/R = [ 1 ][ ][ 0 ] Matrix SingleCoreSections
			WaveStats/Q SingleCoreSections
			CCNumber = Max( CCNumber, V_MaxColLoc )
		EndFor
		If( CCNumber > 9 && V_Flag_CCNumber != 1 )
			DoAlert/T = "CC Section Number Alert" 2, "WARNING: Core catchers appear to use number " + Num2Str( CCNumber ) + " in " + NameOfWave( Matrix ) + ".\r\rDo you want to continue?"
			If( V_Flag == 2 )
				ABORT
			EndIf
			V_Flag_CCNumber = 1
		EndIf
		KillWaves SingleCoreSections
	End