﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function Save_Raw_and_DeSpike( )
		SetDataFolder root:
			String/G G_Hole, G_Technique, G_Data, G_DepthType
			String Hole = G_Hole, Technique = G_Technique, Data = G_Data, DataWv, DepthType = G_DepthType
			Prompt Hole, "Hole"
			Prompt Technique, "Tehnique"
			Prompt Data, "Data"
			Prompt DepthType, "Depth Type ( mbsf, csf, mcd, etc )"
			DoPrompt "Save_Raw_and_DeSpike", Hole, Technique, Data, DepthType
			G_Hole = Hole, G_Technique = Technique, G_Data = Data; G_DepthType = DepthType
			AbortOnValue V_Flag, 0
			Save_Raw_and_DeSpike_F( Hole, Technique, Data, DepthType )
			Print "Save_Raw_and_DeSpike_F( \"" + Hole + "\", \"" + Technique + "\", \"" + Data + "\", \"" + DepthType + "\" )" 
	End

// This function saves the data wave as "_RAW" in a new folder and then sets the despiked wave to the original data wave name. If the RAW wave
// already exists it is not overwritten (this happens when more than 1 despike function is run). The despiked wave will maintain
// a record of all of the steps as a Wavenote.

	Function Save_Raw_and_DeSpike_F( Hole, Technique, Data, DepthType )
			String Hole, Technique, Data, DepthType
		SetDataFolder root:
			String Site = RemoveEnding( Hole ), DataWv, DepthWv
			String/G G_DepthType
			Hole = UpperStr( Hole ); Technique = Capitalize( Technique ); Data = Capitalize( Data ) // Capitalizes parts of wave name - for esthetics
			DataWv = Hole + "_" + Technique + "_" + Data // establish name of data wave
			DepthWv = Hole + "_" + Technique + "_" + G_DepthType // establish name of depth wave
			NewDataFolder/O Xtras
			NewDataFolder/O root:Xtras:$Site + "_" + Technique + "_RAWDATA" // Set up the folder for the raw data
			DFREF RawFldr = root:Xtras:$Site + "_" + Technique + "_RAWDATA" // Set reference for the raw data folder
			WAVE/Z SavedRawWv = RawFldr:$DataWv + "_RAW"
		SetDataFolder $"root:" + Site + "_" + Technique
			Wave/Z RawWv = $DataWv, DeSpkWv = $DataWv +"_DeSpk"//, SavedRawWv = $DataWv + "_RAW" // Set wave references
			If( WaveExists( DeSpkWv ) && WaveExists( SavedRawWv ) ) // Checks to see if RAW data wave has already been saved																										 // If the raw data are already saved, then the despiked wave is renamed as the data wave.
				DoAlert 1, "Rename " + DataWv + "_DeSpk as " + DataWv		
				If( V_Flag == 2 )
					SetDataFolder root:
					ABORT
				EndIf
				Duplicate/O DeSpkWv $DataWv
		 		If( StrSearch( TraceNameList("",";",1), DataWv, 0 ) > -1 ) // If the despk is plotted, remove it from the plot
					RemoveFromGraph/Z $DataWv +"_DeSpk"
				Endif
				KillWaves/Z DeSpkWv
			ElseIf( WaveExists( DeSpkWv ) ) // If the RAW data aren't saved already, they are saved in the new raw data folder
																			 // The despiked data are renamed as the data wave
				DoAlert 1, "Rename " + DataWv + " as " + DataWv + "_RAW" + "\r\rand\r\r" + DataWv +"_DeSpk as " + DataWv + ".\r\rRaw data will be save in a separate folder."
				If( V_Flag == 2 )
					SetDataFolder root:
					ABORT
				EndIf
				Duplicate/O RawWv, RawFldr:$DataWv + "_RAW"
				Duplicate/O $DepthWv, RawFldr:$DepthWv + "_RAW"
				Duplicate/O DeSpkWv $DataWv
		 		If( StrSearch( TraceNameList("",";",1), DataWv, 0 ) > -1 ) // If the despk is plotted, remove it from the plot
					RemoveFromGraph/Z $DataWv +"_DeSpk"
				Endif
				KillWaves/Z DeSpkWv
			Else										// This case simply copies the data wave into the new raw data folder.
				DoAlert 1, "Duplicate " + DataWv + " as " + DataWv + "_RAW"
				If( V_Flag == 2 )
					SetDataFolder root:
					ABORT
				EndIf
				If( WaveExists( $DataWv + "_RAW" ) )
					ABORT DataWv + "_RAW" + " already exists.\r\rIf you really want to overwrite it use the Duplicate command in the Igor data menu."
				Else
					Duplicate/O $DataWv, RawFldr:$DataWv + "_RAW"
					Duplicate/O $DepthWv, RawFldr:$DepthWv + "_RAW"
				EndIf
				KillWaves/Z DeSpkWv
			EndIf	
		SetDataFolder root:
	End

