#pragma rtGlobals=3
		
	Function Site_2_Site_Data_Stretch()
		SetDataFolder root:	
		String/G G_BaseSite, G_StretchSite, G_Technique, G_Data//, G_SpliceID
		String BaseSite = G_BaseSite, StretchSite = G_StretchSite, Technique = G_Technique, Data = G_Data
		Prompt BaseSite "BaseSite"
		Prompt StretchSite "StretchSite"
		Prompt Technique "Technique"
		Prompt Data "Data"
		DoPrompt "Site_2_Site_Data_Stretch" BaseSite, StretchSite, Technique, Data; AbortOnValue V_Flag, 0
		G_BaseSite = BaseSite; G_StretchSite = StretchSite; G_Technique = Technique; G_Data = Data//; G_SpliceID = SpliceID
		Site_2_Site_Data_Stretch_F( BaseSite, StretchSite, Technique, Data )
		Print "Site_2_Site_Data_Stretch_F( \"" + BaseSite +"\", \"" + StretchSite + "\", \"" + Technique + "\", \"" + Data + "\" )"
	End

	*********************************************************
	
	Function Site_2_Site_Data_Stretch_F( BaseSite, StretchSite, Technique, Data )
		String BaseSite, StretchSite, Technique, Data; 
		SetDataFolder root:
		String/G G_BaseSite, G_StretchSite, G_Technique, G_Data
		WAVE BaseTies, StretchTies
		WAVE/T TieType
		CheckTiesForDupes( StretchTies, BaseTies )
		Sort BaseTies StretchTies, BaseTies, TieType		
		PauseUpdate

		SetDataFolder $"root:" + StretchSite + "_" + Technique	
			WAVE StrSiteCCSF = $StretchSite + "S_" + Technique + "_CCSF"
			WAVE StrData = $StretchSite + "S_" + Technique + "_" + Data
			If( !WaveExists( StrData ) )
				ABORT "This function uses the \"S\" identifier for spliced data and I can't find " + StretchSite + "S_" + Technique + "_" + Data + " in the " + StretchSite + "_" + Technique + " data folder.\r\rUse Batch_Rename_Waves to change \"_Splice\" to \"S\""
			Endif

		SetDataFolder $"root:" + BaseSite + "_" + Technique
			WAVE BaseSiteData = $BaseSite + "S_" + Technique + "_" + Data
			WAVE BaseSiteCCSF = $BaseSite + "S_" + Technique + "_CCSF"
			If( !WaveExists( BaseSiteData ) )
				ABORT "This function uses the \"S\" identifier for spliced data and I can't find " + BaseSite + "S_" + Technique + "_" + Data + " in the " + BaseSite + "_" + Technique + " data folder.\r\rUse Batch_Rename_Waves to change \"_Splice\" to \"S\""
			Endif

		SetDataFolder $"root:" + BaseSite + "_" + StretchSite + "_Results"
			Duplicate/O BaseTies $BaseSite + "_2_" + StretchSite + "_Ties"
			Duplicate/O StretchTies $StretchSite + "_2_" + BaseSite + "_Ties"
			Duplicate/O TieType $StretchSite + "_2_" + BaseSite + "_TieType"
			Duplicate/O StrSiteCCSF $StretchSite + "S_" + Technique + "_CCSF" + BaseSite	
			WAVE StretchedCCSF = $StretchSite + "S_" + Technique + "_CCSF" + BaseSite
			StretchedCCSF = interp( StrSiteCCSF, StretchTies, BaseTies ) 
			Variable V_BSdeep		// Trying to get CCSFs below the deepest BaseTies tiepoint to be returned as NAN
			V_BSdeep = WaveMax( BaseTies )			//Make and define the V_BSdeep variable as the deepest tiepoint in BaseTies.		
			StretchedCCSF = StretchedCCSF > V_BSdeep ? NaN : StretchedCCSF			//When CCSFs is greater than V_BSdeep, return NaNs
		SetDataFolder $"root:Xtras"
			WAVE Ones, Numbers
			Ones = .5; Numbers = x
	 		Duplicate/O StretchTies $"Stretch_" + Data + "_Val"
			WAVE StretchVal = $"Stretch_" + Data + "_Val"
			StretchVal  = interp( StretchTies, StrSiteCCSF, StrData )
			Duplicate/O StretchTies $"Base_" + Data + "_Val"
			WAVE BaseVal = $"Base_" + Data + "_Val"
			BaseVal  = interp( BaseTies, BaseSiteCCSF, BaseSiteData )
		SetDataFolder root:
	End
	

	
//	Function Site_2_Site_Data_Stretch_F( BaseSite, StretchSite, Technique, Data, SpliceID )
		String BaseSite, StretchSite, Technique, Data, SpliceID; 
		SetDataFolder root:
		String/G G_BaseSite, G_StretchSite, G_Technique, G_Data
		WAVE BaseTies, StretchTies
		CheckTiesForDupes( StretchTies, BaseTies )
		Sort BaseTies StretchTies, BaseTies		
		PauseUpdate
		SetDataFolder $"root:" + StretchSite + "_" + Technique	
			WAVE StrSiteCCSF = $StretchSite + SpliceID + Technique + "_CCSF"
			WAVE StrData = $StretchSite + SpliceID + Technique + "_" + Data
		SetDataFolder $"root:" + BaseSite + "_" + Technique
			WAVE BaseSiteData = $BaseSite + SpliceID + Technique + "_" + Data
			WAVE BaseSiteCCSF = $BaseSite + SpliceID + Technique + "_CCSF"
		SetDataFolder $"root:" + BaseSite + "_" + StretchSite + "_Results"
			Duplicate/O BaseTies $BaseSite + "_2_" + StretchSite + "_Ties"
			Duplicate/O StretchTies $StretchSite + "_2_" + BaseSite + "_Ties"
			Duplicate/O StrSiteCCSF $StretchSite + SpliceID + Technique + "_CCSF" + BaseSite	
			WAVE StretchedCCSF = $StretchSite + SpliceID + Technique + "_CCSF" + BaseSite
			StretchedCCSF = interp( StrSiteCCSF, StretchTies, BaseTies ) 
			Variable V_BSdeep		// Trying to get CCSFs below the deepest BaseTies tiepoint to be returned as NAN
			V_BSdeep = WaveMax( BaseTies )			//Make and define the V_BSdeep variable as the deepest tiepoint in BaseTies.		
			StretchedCCSF = StretchedCCSF > V_BSdeep ? NaN : StretchedCCSF			//When CCSFs is greater than V_BSdeep, return NaNs
		SetDataFolder $"root:Xtras"
			WAVE Ones, Numbers
			Ones = .5; Numbers = x
	 		Duplicate/O StretchTies $"Stretch_" + Data + "_Val"
			WAVE StretchVal = $"Stretch_" + Data + "_Val"
			StretchVal  = interp( StretchTies, StrSiteCCSF, StrData )
			Duplicate/O StretchTies $"Base_" + Data + "_Val"
			WAVE BaseVal = $"Base_" + Data + "_Val"
			BaseVal  = interp( BaseTies, BaseSiteCCSF, BaseSiteData )
		SetDataFolder root:
	End
	

