#pragma rtGlobals=3		// Use modern global access method.

//	Function Age_Spectrogram( )
		SetDataFolder root:
			String/G G_Data_Wave, G_OutPutName;
			String Data = G_Data_Wave, OutPutName = G_OutPutName
			Variable/G G_S_end, G_S_start, G_Jump, G_Taper_Length, G_Fit, G_Segment_Length, G_Sed_Rate
			Variable i = 0, j = 1, Interval
			Variable Points, S_end = G_S_end, S_start = G_S_start, Jump = G_Jump, P_Start;
			Variable Segment_Points,  Segment_Length = G_Segment_Length;
			String/G G_DataFolder
			String DataFolder = G_DataFolder
			Prompt DataFolder, "DataFolder", popup, "root:;" + FolderList( "*" )
			DoPrompt "Age_Spectrogram", DataFolder; AbortOnValue V_Flag, 0
			G_DataFolder = DataFolder
		SetDataFolder $DataFolder
			Prompt Data, "Data Wave ( interpolated data with age ):", popup, WaveList("*_I*",";","")
			Prompt Segment_Length, "Segment Length ( my ): "
			Prompt S_start, "Starting Point ( Ma ):";
			Prompt S_end, "Ending Point ( Ma ):";
			Prompt Jump, "Jump ( my ):";
			Prompt OutPutName, "Output Name?:"
			DoPrompt "Age_Spetrogram", Data, Segment_Length, S_Start, S_End, Jump, OutPutName; AbortOnValue V_Flag, 0
			G_OutPutName = OutPutName; G_Segment_Length = Segment_Length; G_S_start = S_start;
			G_S_end = S_end; G_Jump = Jump; G_Data_Wave = Data	
			Age_Spectrogram_F( DataFolder, Data, Segment_Length, S_Start, S_End, Jump, OutPutName )
			Print "Age_Spectrogram_F( \"" + DataFolder + "\", \"" + Data + "\",", Segment_Length,",", S_Start,",", S_End,",", Jump,", \"" + OutPutName + "\" )"
	End

----------------------------------------

//	Function Age_Spectrogram_F( DataFolder, Data, Segment_Length, S_Start, S_End, Jump, OutPutName )
			String DataFolder, Data, OutPutName
			Variable S_end, S_start, Jump, Segment_Length
		SetDataFolder root:
			Variable/G G_S_End, G_Sed_Rate
			Variable i = 0, j = 1, Interval
			Variable Points, P_Start;
			Variable Segment_Points, Total_Points
		SetDataFolder $DataFolder
			WAVE DataWave = $Data
			Segment_Points = Segment_Length / DimDelta( DataWave, 0 )
			ToTal_Points = 2 ^ ( PowerOf2( Segment_Points ) ) // This pads the segment to be processed to the next highest power of 2
			total_points *= 10
			Variable JumpPnts = Jump / dimdelta( DataWave,0 )
			If( S_End > RightX( DataWave ) )
				S_End = RightX( DataWave )
				G_S_End = RightX( DataWave )
				DoAlert 1, "The ending age you have chosen is deeper than the bottom of the data wave.\rThe end age will be reset to the bottom of the data wave.\r\rDo you want to continue?" 
				If( V_Flag == 2 )
					ABORT
				EndIf
			EndIf
			Print "Segment Span in Points:", Round( Segment_Points ), ",  in Yrs:", Segment_Length, "my"
			Print "Total Points in the FFT segments:", Total_Points
			Print "Jump in Points:", Round( JumpPnts )
			Print "Start", S_Start, "  End", S_End

// This section reflects the first segment and last segment at either end of the datawave

			Duplicate/O/R = [ 0, ( Segment_Points ) ] DataWave, DataWvPlus
			DeletePoints 0, 1, DataWvPlus
			Variable DataWvPlusBottom = RightX( DataWvPlus )
			Reverse DataWvPlus
			SetScale/P x -DataWvPlusBottom, DimDelta( DataWave, 0 ), DataWvPlus
			Variable Delta = RightX( DataWvPlus ) - LeftX( DataWave ) 
			SetScale/P x, ( -DataWvPlusBottom - Delta ), DimDelta( DataWave, 0 ), DataWvPlus
			Concatenate/NP { DataWave }, DataWvPlus
			Variable NPnts = NumPnts( DataWvPlus )
			Duplicate/O/R = [ NPnts - 1, NPnts - Segment_Points ] DataWvPlus, Temp
			Reverse Temp
			DeletePoints 0, 1, Temp
			Concatenate/NP { Temp }, DataWvPlus
			KillWaves Temp

		SetDataFolder root:Xtras
			WAVE Freq, Ones, Period
			Interval = DimDelta( DataWave, 0 )
			Points = NumPnts( DataWave )
			Make/O/N = ( ( Total_Points / 2) + 1 ) Power;
			Variable SpectYSize = ( S_End - S_Start ) / Jump
			Make/O/N=( ( ( Total_Points / 2 ) + 1 ) , ( SpectYSize + 1 ) ) PMatrixAge, NMatrixAge;
			SetScale/P y S_Start, Jump, PMatrixAge, NMatrixAge
			PMatrixAge = NaN;
			NMatrixAge = NaN;
			Variable SpectrumDepth = S_Start, SegPointStart, SegDepthStart, SegPointEnd, SegDepthEnd
			Duplicate/O Period Freq4Plotting, SpecAgeMax
			Freq4Plotting = 1 / Period 
			SpecAgemax = S_End

// This sction sets up the scales for Power and the Spectrograms

			SegDepthStart = SpectrumDepth - ( 0.5 * Segment_Length )
			SegPointStart = X2Pnt( DataWvPlus, SegDepthStart )			
			SegDepthEnd = SpectrumDepth + ( 0.5 * Segment_Length )
			SegPointEnd = X2Pnt( DataWvPlus, SegDepthEnd )			
			Duplicate/O/R = ( SegDepthStart , SegDepthEnd ) DataWvPlus  Section, FFTSegment
			Hanning FFTSegment
			Redimension/N = ( Total_Points ) FFTSegment;
			FFT/MAGS /DEST = Power FFTSegment;
			CopyScales Power PMatrixAge, NMatrixAge;

// This loop calculates the successive spectra

			For( i = 0; SpectrumDepth <= S_End; i += 1 )
				SegDepthStart = SpectrumDepth - ( 0.5 * Segment_Length )
				SegPointStart = X2Pnt( DataWvPlus, SegDepthStart )			
				SegDepthEnd = SpectrumDepth + ( 0.5 * Segment_Length )
				SegPointEnd = X2Pnt( DataWvPlus, SegDepthEnd )			
				Duplicate/O/R = ( SegDepthStart , SegDepthEnd ) DataWvPlus  Section, FFTSegment
//				Correlate/Auto FFTSegment, FFTSegment; // This process can be used instead of the Hanning Filter or in addition to Hanning
				Hanning FFTSegment // Hanning filters the data segment with a modified Gaussian curve, bringing the endpoints to 0
				Redimension/N = ( Total_Points ), FFTSegment;
//				FFT/MAG /DEST = Power FFTSegment; // This is for Magnitude.
				FFT/MAGS /DEST = Power FFTSegment; // This is for Magntude Squared ( Power ), which enhances higher peaks.
				PMatrixAge[ ] [ i ] = Power[ p ];
				Variable PowerMax = WaveMax( Power )
				Power /= PowerMax
				Smooth 3, Power // Smoothing the spectra can make it a little easier to pick peaks in complicated data
				NMatrixAge[ ] [ i ] = Power[ p ];
				SpectrumDepth += Jump
			EndFor
			NOTE NMatrixAge,"Spectrogram_F( \"" +DataFolder+"\", \""+Data+"\","+Num2Str(Segment_Length)+","+Num2Str(S_Start)+","+ Num2Str(S_End)+","+Num2Str(Jump)+", \""+OutPutName+"\" )"
		NewDataFolder/O/S $"root:" + OutPutName
				Duplicate/O NMatrixAge $OutPutName + "_NormAmpAge"
				Duplicate/O PMatrixAge $OutPutName + "_RawAmpAge"
		SetDataFolder root:
			If( !StrLen( WinList( "NormAmpAge", ";", "" ) ) )
				Norm_AmpAge( )
			Else
				DoWindow/F NormAmpAge			
			EndIf
			If( StrLen( ContourNameList( "", ";" ) ) )
				RemoveContour NMatrixAge
			EndIf
			AppendMatrixContour NMatrixAge; DelayUpdate
			ModifyContour NMatrixAge labels=0, ManLevels = { 0.1, 0.15, 1 }
			If( StrSearch( TraceNameList( "", ";", 3 ),"SpecAgeMax",  0 ) == -1 )
				AppendToGraph SpecAgeMax vs Freq4Plotting
				ModifyGraph mode(SpecAgeMax)=1,lsize(SpecAgeMax)=3
			Endif
			If( !StrLen( WinList( "AgePowerWindow", ";", "" ) ) )
				AgePower( )
			EndIf
			KillWaves/Z DataWvPlus, FFTSegment, Section
	End		

----------------------------------------
