#pragma rtGlobals=1		// Use modern global access method.
	
	Function Make_Residual( )
		SetDataFolder root:
			Variable/G G_Smoothing_Number
			Variable Smoothing_Number = G_Smoothing_Number
			String/G G_Data_Wave, G_Smooth_FNC, G_Site, G_DataFolder
			String Data_Wave = G_Data_Wave, Smooth_Fnc = G_Smooth_FNC, DataFolder = G_DataFolder
			Prompt DataFolder, "Data Folder", popup, "root:;" + FolderList( "*" )
			DoPrompt "Make_Residual", DataFolder; AbortOnValue V_Flag, 0
			G_DataFolder = DataFolder
		SetDataFolder $DataFolder
			Prompt Smooth_Fnc, "Smoothing Function", popup "Gauss;BoxCar"
			Prompt Data_Wave, "Interpolated Wave to Smooth:", popup, Wavelist("*_I*",";","")
			Prompt Smoothing_Number, "Smoothing Number/BoxWidth (data points):"
			DoPrompt "Make_Residual", Data_Wave, Smooth_Fnc, Smoothing_Number; //AbortOnValue V_Flag, 0
			G_Data_Wave = Data_Wave; G_Smooth_Fnc = Smooth_Fnc; G_Smoothing_Number = Smoothing_Number
			If( V_Flag )
				SetDataFolder root:
				ABORT
			EndIf
			Make_Residual_F( DataFolder, Smooth_Fnc, Data_Wave, Smoothing_Number )
			Print "Make_Residual_F( \"" + DataFolder +"\", \"" + Smooth_Fnc + "\", \"" + Data_Wave +"\", " + Num2Str( Smoothing_Number ) + " )"
	End

-----------------------------------------------------------------
	
	Function Make_Residual_F( DataFolder, Smooth_Fnc, Data_Wave, Smoothing_Number )
			Variable Smoothing_Number
			String Data_Wave, Smooth_Fnc, DataFolder
		SetDataFolder root:
			String/G G_Site
		SetDataFolder $DataFolder
			WAVE DataWave = $Data_Wave
			PauseUpdate;
			If( Smoothing_Number > 32000 )
				Abort "Smoothing Number must be less than 32,000."
			EndIf
			Duplicate/O DataWave, $Data_Wave + "_smth"
			WAVE SmData = $Data_Wave+"_smth"
			If( StringMatch( Smooth_Fnc, "BoxCar") )
				Smooth/B Smoothing_Number, SmData
			Else
				Smooth Smoothing_Number, SmData
			EndIf
			Duplicate/O SmData $Data_Wave+"_R"
			WAVE Residual = $Data_Wave+"_R"
			NOTE/K Residual, "Make_Residual_F( \"" + DataFolder +"\", \"" + Smooth_Fnc + "\", \"" + Data_Wave +"\", " + Num2Str( Smoothing_Number ) + " )"
			Residual = DataWave - SmData
			If( !( StrSearch( WinList( "*", ";", "WIN:1" ) , "ResidualPlot", 0 ) + 1 )  )
				ResidualDataPlot( Residual, SmData, DataWave )
			EndIf
			Make/O/N = ( NumPnts( DataWave ) ) InterpDataPolyAge
			Duplicate/O Residual InterpDataDepth
			Wave InterpDataPolyAge = InterpDataPolyAge, PolyAge = $"root:Poly_Predictions:" + G_Site + "_PolyAge"
			WAVE PolyDepth = $"root:Poly_Predictions:" + G_Site + "_PolyDepth"//, DataDepth = $"root:Xtras:DataDepth"
			InterpDataDepth = x
			InterpDataPolyAge = interp( InterpDataDepth, PolyDepth, PolyAge )
		SetDataFolder root:
	EndMacro

-----------------------------------------------------------------
	
	Function ResidualDataPlot( Residual, SmData, DataWave ) : Graph
		WAVE Residual, SMData, DataWave
		Display /W=( 570, 47, 1220, 374 ) /L = Residual Residual
		AppendToGraph/L = Data DataWave, SmData
		ModifyGraph axisEnab( Residual )= { 0.5, 1 }, axisEnab( Data ) = { 0, 0.5 }
		ModifyGraph rgb[ 0 ] = ( 0, 0, 65535 )
		ModifyGraph rgb[ 2 ] = ( 0, 0, 0 )
		ModifyGraph rgb[ 1 ] = (0,65535,0 )
		ModifyGraph freePos (Residual ) = 0, freePos( Data ) = 0
		ModifyGraph lsize[ 2 ] = 2
		DoWindow/C ResidualPlot
		Legend/C/A = MC /N = text0
		ShowInfo
	EndMacro

----------------------
